﻿Type=Class
Version=4.2
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module KCButton

#Event: Click
#Event: LongClick
#RaisesSynchronousEvents: Click
#RaisesSynchronousEvents: LongClick

#DesignerProperty: Key: ImageFileName, DisplayName: ImageFileName, FieldType: String, DefaultValue: , Description: Generic image filename.
#DesignerProperty: Key: ToolTipTextClick, DisplayName: ToolTipTextClick, FieldType: String, DefaultValue: , Description: Text for the tooltip.
#DesignerProperty: Key: ToolTipTextLongClick, DisplayName: ToolTipTextLongClick, FieldType: String, DefaultValue: , Description: Text for the tooltip.
#DesignerProperty: Key: ToolTipTextDoNothing, DisplayName: ToolTipTextDoNothing, FieldType: String, DefaultValue: Do nothing.
#DesignerProperty: Key: PermanentToolTip, DisplayName: PermanentToolTip, FieldType: Boolean, DefaultValue: False, Description: Keep the tooltop permanent.
#DesignerProperty: Key: ToolTipTextPermanent, DisplayName: ToolTipTextPermanent, FieldType: String, DefaultValue: , Description: Text for the permanent tooltip.

Sub Class_Globals
	Private fx As JFX
	Private cEventName As String
	Private cCallBack As Object
	Private lblToolTip As Label
	Private cToolTipTextClick As String
	Private cToolTipTextLongClick As String
	Private cToolTipTextDoNothing = "Do nothing" As String
	Private cToolTipTextPermanent As String
	Private cPermanentToolTip = False As Boolean
	Private LongClickTime As Long
	Private pnlBase, pnlButton As Pane
	Private cParent, mBase As Pane
	Private cLeft, cTop, cWidth, cHeight As Int
	Private cImageFileName As String
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	cEventName = EventName
	cCallBack = Callback
End Sub

Public Sub DesignerCreateView (Base As Pane, Lbl As Label, Props As Map)
'	If GetType(Base.Parent) = "javafx.scene.layout.AnchorPane" Then
		cParent = Base.Parent
'	Else
'		cActivity = Base.Parent
'	End If
	cLeft = Base.Left
	cTop = Base.Top
	cWidth = Base.Width
	cHeight = Base.Height
	
	
	pnlBase = Base
	pnlButton.Initialize("pnlButton")
'	pnlButton.Style = Base.Style

'	Base.RemoveNodeFromParent
'	pnlButton = Base
	
	cImageFileName = Props.Get("ImageFileName")
	cToolTipTextClick = Props.Get("ToolTipTextClick")
	cToolTipTextLongClick = Props.Get("ToolTipTextLongClick")
	cToolTipTextDoNothing = Props.Get("ToolTipTextDoNothing")
	cPermanentToolTip = Props.Get("PermanentToolTip")
	cToolTipTextPermanent = Props.Get(" ToolTipTextPermanent")
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	cWidth = Width
	cHeight = Height
	pnlBase.AddNode(pnlButton, 0, 0, cWidth, cHeight)
	CSSUtils.SetBackgroundImage(pnlButton, File.DirAssets, cImageFileName & "0.png")
End Sub

'Adds the KCButton onto the parent view
'Parent = parent view, must be an Activity or a Panel
'Left, Top, Width, Height = position and dimensions of the KCButton
'ImageFileName = generic file name for the bitmaps
'ToolTipLabel = Label to display the too tips
'ToolTipTextClick = tool tip text for click
'ToolTipTextLongClick = tool tip text for click
'PermanentToolTip = True = maintains the tool tip when checked
'ToolTipTextPermanent = permanent tool tip text 
Public Sub AddToParent(Parent As Pane, Left As Int, Top As Int, Width As Int, Height As Int, ImageFileName As String, ToolTipLabel As Label, ToolTipTextClick As String, ToolTipTextLongClick As String, PermanentToolTip As Boolean, ToolTipTextPermanent As String)
	cParent = Parent
	cLeft = Left
	cTop = Top
	cWidth = Width
	cHeight = Height

	cImageFileName = ImageFileName
	cToolTipTextClick = ToolTipTextClick
	cToolTipTextLongClick = ToolTipTextLongClick
	cPermanentToolTip = PermanentToolTip
	cToolTipTextPermanent = ToolTipTextPermanent
	lblToolTip = ToolTipLabel
	
	pnlButton.Initialize("pnlButton")

	cParent.AddNode(pnlButton, cLeft, cTop, cWidth, cHeight)
	CSSUtils.SetBackgroundImage(pnlButton, File.DirAssets, cImageFileName & "0.png")
End Sub

Private Sub pnlButton_MousePressed(EventData As MouseEvent)
	LongClickTime = DateTime.Now
	lblToolTip.Text = cToolTipTextClick
	CSSUtils.SetBackgroundImage(pnlButton, File.DirAssets, cImageFileName & "1.png")
End Sub

Private Sub pnlButton_MouseDragged(EventData As MouseEvent)
	If EventData.X > 0 And EventData.X < pnlButton.Width And EventData.Y > 0 And EventData.Y < pnlButton.Height Then
		lblToolTip.Text = cToolTipTextClick
		If DateTime.Now - LongClickTime > 1000 And SubExists(cCallBack, cEventName & "_LongClick") Then
			lblToolTip.Text = cToolTipTextLongClick
		End If
	Else
		lblToolTip.Text = cToolTipTextDoNothing
	End If	
End Sub

Private Sub pnlButton_MouseReleased(EventData As MouseEvent)
	If EventData.X > 0 And EventData.X < pnlButton.Width And EventData.Y > 0 And EventData.Y < pnlButton.Height Then
		Dim CallBackRoutine As String
		If DateTime.Now - LongClickTime > 1000 And SubExists(cCallBack, cEventName & "_LongClick") Then
			CallBackRoutine = cEventName & "_LongClick"
		Else 
			CallBackRoutine = cEventName & "_Click"
		End If
	Else
		cPermanentToolTip = False
	End If
	If cPermanentToolTip = False Then
		lblToolTip.Text = ""
	Else
		lblToolTip.Text = cToolTipTextPermanent
	End If
	CSSUtils.SetBackgroundImage(pnlButton, File.DirAssets, cImageFileName & "0.png")
	If SubExists(cCallBack, CallBackRoutine) Then
		CallSub(cCallBack, CallBackRoutine)
	End If
End Sub

Private Sub pnlButton_Touch (Action As Int, X As Float, Y As Float)
	
	Select Action
	Case 0	' ACTION_DOWN
		LongClickTime = DateTime.Now
		lblToolTip.Text = cToolTipTextClick
		CSSUtils.SetBackgroundImage(pnlButton, File.DirAssets, cImageFileName & "1.png")
	Case 2	' ACTION_MOVE
		If X > 0 And X < pnlButton.Width And Y > 0 And Y < pnlButton.Height Then
			lblToolTip.Text = cToolTipTextClick
			If DateTime.Now - LongClickTime > 1000 And SubExists(cCallBack, cEventName & "_LongClick") Then
				lblToolTip.Text = cToolTipTextLongClick
			End If
		Else
			lblToolTip.Text = cToolTipTextDoNothing
		End If
	Case 1	' ACTION_UP
'		Dim bdw As BitmapDrawable
		If X > 0 And X < pnlButton.Width And Y > 0 And Y < pnlButton.Height Then
			Dim CallBackRoutine As String
			If DateTime.Now - LongClickTime > 1000 And SubExists(cCallBack, cEventName & "_LongClick") Then
				CallBackRoutine = cEventName & "_LongClick"
			Else 
				CallBackRoutine = cEventName & "_Click"
			End If
		Else
			cPermanentToolTip = False
		End If
		If cPermanentToolTip = False Then
			lblToolTip.Text = ""
		Else
			lblToolTip.Text = cToolTipTextPermanent
		End If
		CSSUtils.SetBackgroundImage(pnlButton, File.DirAssets, cImageFileName & "0.png")
		If SubExists(cCallBack, CallBackRoutine) Then
			CallSub(cCallBack, CallBackRoutine)
		End If
	End Select	
End Sub

'gets or sets the Left propety
Public Sub setLeft(Left As Int)
	pnlButton.Left = Left
End Sub

Public Sub getLeft As Int
	Return pnlButton.Left
End Sub

'gets or sets the Top propety
Public Sub setTop(Top As Int)
	pnlButton.Top = Top
End Sub

Public Sub getTop As Int
	Return pnlButton.Top
End Sub

'gets or sets the Width propety
Public Sub setWidth(Width As Int)
	cWidth = Width
	pnlButton.SetSize(cWidth, cHeight)
End Sub

Public Sub getWidth As Int
	Return pnlButton.Width
End Sub

'gets or sets the Height propety
Public Sub setHeight(Height As Int)
	cHeight = Height
	pnlButton.SetSize(cWidth, cHeight)
End Sub

Public Sub getHeight As Int
	Return pnlButton.Height
End Sub

'gets or sets the ToolTipLabel
Public Sub setToolTipLabel(Label As Label)
	lblToolTip = Label
End Sub

Public Sub getToolTipLabel As Label
	Return lblToolTip
End Sub

'gets the base pane
Public Sub getBasePane As Pane
	Return pnlButton
End Sub

'gets or sets the ToolTipTextDoNothing property
Public Sub setToolTipTextDoNothing(Text As String)
	cToolTipTextDoNothing = Text
End Sub

Public Sub ToolTipTextDoNothing As String
	Return ToolTipTextDoNothing
End Sub