﻿Type=Class
Version=4.2
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module KCToggleButton

#Event: CheckedChange(Checked As Boolean)
#RaisesSynchronousEvents: CheckedChange

#DesignerProperty: Key: ImageFileName, DisplayName: ImageFileName, FieldType: String, DefaultValue: , Description: Generic image filename.
#DesignerProperty: Key: ToolTipTextChecked, DisplayName: ToolTipTextChecked, FieldType: String, DefaultValue: , Description: Text for the checked tooltip.
#DesignerProperty: Key: ToolTipTextUnChecked, DisplayName: ToolTipTextUnChecked, FieldType: String, DefaultValue: , Description: Text for the unchecked tooltip.
#DesignerProperty: Key: ToolTipTextDoNothing, DisplayName: ToolTipTextDoNothing, FieldType: String, DefaultValue: Do nothing.
#DesignerProperty: Key: PermanentToolTip, DisplayName: PermanentToolTip, FieldType: Boolean, DefaultValue: False, Description: Keep the tooltop permanent.
#DesignerProperty: Key: ToolTipTextPermanent, DisplayName: ToolTipTextPermanent, FieldType: String, DefaultValue: , Description: Text for the permanent tooltip.

Sub Class_Globals
	Private cEventName As String
	Private cCallBack As Object
	Private lblToolTip As Label
	Private cToolTipTextChecked As String
	Private cToolTipTextUnChecked As String
	Private cToolTipTextDoNothing = "Do nothing" As String
	Private cPermanentToolTip = False As Boolean
	Private cToolTipTextPermanent As String
	Private cChecked As Boolean
'	Private cParent As Panel
	Private cLeft, cTop, cWidth, cHeight As Int
	Private pnlBase As Pane
	Private pnlButton As Pane
	Private cImageFileName As String
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	cEventName = EventName
	cCallBack = Callback
End Sub

Public Sub DesignerCreateView (Base As Pane, Lbl As Label, Props As Map)
'	cParent = Base.Parent
	cLeft = Base.Left
	cTop = Base.Top
	cWidth = Base.Width
	cHeight = Base.Height

'	Base.RemoveView
	
	pnlBase = Base
	pnlButton.Initialize("pnlButton")
'	pnlButton.Background = Base.Background

	cImageFileName = Props.Get("ImageFileName")
	cToolTipTextChecked = Props.Get("ToolTipTextChecked")
	cToolTipTextUnChecked = Props.Get("ToolTipTextUnChecked")
	cToolTipTextDoNothing = Props.Get("ToolTipTextDoNothing")
	cPermanentToolTip = Props.Get("PermanentToolTip")
	cToolTipTextPermanent = Props.Get("ToolTipTextPermanent")

'	cParent.AddView(pnlButton, cLeft, cTop, cWidth, cHeight)
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	cWidth = Width
	cHeight = Height
	pnlBase.AddNode(pnlButton, 0, 0, cWidth, cHeight)
	CSSUtils.SetBackgroundImage(pnlButton, File.DirAssets, cImageFileName & "0.png")
End Sub

'Adds the KCToggleButton onto the parent view
'Parent = parent view, must be an Activity or a Panel
'Left, Top, Width, Height = position and dimensions of the KCButton
'ImageFileName = generic file name for the bitmaps
'ToolTipLabel = Label to display the too tips
'ToolTipTextChecked = tool tip text for the checked state
'ToolTipTextUnChecked = tool tip text for the unchecked state
'PermanentToolTip = True = maintains the tool tip when checked
'ToolTipTextPermanent = permanent tool tip text 
Public Sub AddToParent(Parent As Pane, Left As Int, Top As Int, Width As Int, Height As Int, ImageFileName As String, ToolTipLabel As Label, ToolTipTextChecked As String, ToolTipTextUnChecked As String, PermanentToolTip As Boolean, ToolTipTextPermanent As String)
'	cParent = Parent
	cLeft = Left
	cTop = Top
	cWidth = Width
	cHeight = Height

	cImageFileName = ImageFileName
	cToolTipTextChecked = ToolTipTextChecked
	cToolTipTextUnChecked = ToolTipTextUnChecked
	lblToolTip = ToolTipLabel
	cPermanentToolTip = PermanentToolTip
	cToolTipTextPermanent = ToolTipTextPermanent
	
	pnlButton.Initialize("pnlButton")
	CSSUtils.SetBackgroundImage(pnlButton, File.DirAssets, cImageFileName & "0.png")
	
'	cParent.AddView(pnlButton, cLeft, cTop, cWidth, cHeight)
End Sub

Private Sub pnlButton_MousePressed(EventData As MouseEvent)
	If cChecked = False Then
		lblToolTip.Text = cToolTipTextChecked
	Else
		lblToolTip.Text = cToolTipTextUnChecked
	End If
	CSSUtils.SetBackgroundImage(pnlButton, File.DirAssets, cImageFileName & "1.png")
End Sub

Private Sub pnlButton_MouseDragged(EventData As MouseEvent)
	If EventData.X > 0 And EventData.X < pnlButton.Width And EventData.Y > 0 And EventData.Y < pnlButton.Height Then
		If cChecked = False Then
			lblToolTip.Text = cToolTipTextChecked
		Else
			lblToolTip.Text = cToolTipTextUnChecked
		End If
	Else
		lblToolTip.Text = cToolTipTextDoNothing
	End If	
End Sub

Private Sub pnlButton_MouseReleased(EventData As MouseEvent)
	If EventData.X > 0 And EventData.X < pnlButton.Width And EventData.Y > 0 And EventData.Y < pnlButton.Height Then
		cChecked = Not(cChecked)
	Else
		cPermanentToolTip = False
	End If
	
	If cPermanentToolTip = False Then
		lblToolTip.Text = ""
	Else
		lblToolTip.Text = cToolTipTextPermanent
	End If
	
	If cChecked = False Then
		CSSUtils.SetBackgroundImage(pnlButton, File.DirAssets, cImageFileName & "0.png")
	Else
		CSSUtils.SetBackgroundImage(pnlButton, File.DirAssets, cImageFileName & "2.png")
	End If
	If SubExists(cCallBack, cEventName & "_CheckedChange") Then
		CallSub2(cCallBack, cEventName & "_CheckedChange", cChecked)
	End If
End Sub

'gets or sets the Left propety
Public Sub setLeft(Left As Int)
	pnlButton.Left = Left
End Sub

Public Sub getLeft As Int
	Return pnlButton.Left
End Sub

'gets or sets the Top propety
Public Sub setTop(Top As Int)
	pnlButton.Top = Top
End Sub

Public Sub getTop As Int
	Return pnlButton.Top
End Sub

'gets or sets the Width propety
Public Sub setWidth(Width As Int)
'	pnlButton.Width = Width
End Sub

Public Sub getWidth As Int
	Return pnlButton.Width
End Sub

'gets or sets the Height propety
Public Sub setHeight(Height As Int)
'	pnlButton.Height = Height
End Sub

Public Sub getHeight As Int
	Return pnlButton.Height
End Sub

'gets or sets the ToolTipLabel
Public Sub setToolTipLabel(Label As Label)
	lblToolTip = Label
End Sub

Public Sub getToolTipLabel As Label
	Return lblToolTip
End Sub

'gets or sets the ToolTipTextDoNothing property
Public Sub setToolTipTextDoNothing(Text As String)
	cToolTipTextDoNothing = Text
End Sub

Public Sub ToolTipTextDoNothing As String
	Return ToolTipTextDoNothing
End Sub